package io.gmss.fiscad.implementations.infocad.parametre;

import io.gmss.fiscad.entities.infocad.parametre.SituationGeographique;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.infocad.parametre.SituationGeographiqueService;
import io.gmss.fiscad.repositories.infocad.parametre.SituationGeographiqueRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class SituationGeographiqueServiceImpl implements SituationGeographiqueService {

    private final SituationGeographiqueRepository situationGeographiqueRepository;

    public SituationGeographiqueServiceImpl(SituationGeographiqueRepository situationGeographiqueRepository) {
        this.situationGeographiqueRepository = situationGeographiqueRepository;
    }

    @Override
    public SituationGeographique createSituationGeographique(SituationGeographique situationGeographique) throws BadRequestException {
        if (situationGeographique.getId() != null) {
            throw new BadRequestException("Impossible de créer une nouvelle situation géographique ayant un id non null.");
        }
        return situationGeographiqueRepository.save(situationGeographique);
    }

    @Override
    public SituationGeographique updateSituationGeographique(Long id, SituationGeographique situationGeographique) throws NotFoundException {
        if (situationGeographique.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour une nouvelle situation géographique ayant un id null.");
        }
        if (!situationGeographiqueRepository.existsById(situationGeographique.getId())) {
            throw new NotFoundException("Impossible de trouver la situation géographique spécifiée dans notre base de données.");
        }
        return situationGeographiqueRepository.save(situationGeographique);
    }

    @Override
    public void deleteSituationGeographique(Long id) throws NotFoundException {
        Optional<SituationGeographique> situationGeographiqueOptional = situationGeographiqueRepository.findById(id);
        if (situationGeographiqueOptional.isPresent()) {
            situationGeographiqueRepository.deleteById(situationGeographiqueOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver la situation géographique spécifiée dans notre base de données.");
        }
    }

    @Override
    public Page<SituationGeographique> getSituationGeographiqueList(Pageable pageable) {
        return situationGeographiqueRepository.findAll(pageable);
    }

    @Override
    public List<SituationGeographique> getSituationGeographiqueList() {
        return situationGeographiqueRepository.findAll();
    }

    @Override
    public Optional<SituationGeographique> getSituationGeographiqueById(Long id) {
        if (situationGeographiqueRepository.existsById(id)) {
            return situationGeographiqueRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver la situation géographique spécifiée dans la base de données.");
        }

    }
}
